class Position
{
    public:

	void	SetName( const char *journal, StrPtr *ival );
	void	SetOffset( off_tL soffset );

	char	*GetName();
	off_tL	GetOffset();

	bool	Init( const char *journal, StrPtr *ival, Error *e );

	bool	Open( Error *e );
	bool	Seek( off_t poffset, const char *op, Error *e );
	bool	Read( Error *e );
	bool	Increment( off_tL increment, Error *e );
	bool	Write( Error *e );
	bool	Truncate( Error *e );
	bool	Close( Error *e );

    private:

	StrBuf name;
	int positionfd;
	off_tL offset;
};
